library(MASS)
set.seed(426)

generate_uniform_blob <- function(num, shiftx,shifty,rad){
  t = runif(num, 0.0, 2.0*pi)
  r = rad*sqrt(runif(num, 0.0,1.0))
  x = r*cos(t)+shiftx
  y = r*sin(t)+shifty
  return(list(x,y))
}

cl1 <- 200
points <- generate_uniform_blob(cl1, 1, 1.1, 0.25)
x1 <- points[[1]]
y1 <- points[[2]]+0.1

cl2 <- 150
points <- generate_uniform_blob(cl2, 1, 2.3, 0.40)
x2 <- points[[1]]
y2 <- points[[2]]+0.00

cl3 <- 200
x3 <- 1 + cos(seq(0,pi,(pi/(cl3-1))))*0.7 + runif(cl3, -0.05, 0.05)
y3 <- 2.75 + -sin(seq(0,pi,(pi/(cl3-1))))*1 +runif(cl3, -0.05, 0.05)

x <- c(x1,x2,x3)
y <- c(y1,y2,y3)
labels <-c(rep(1,cl1), rep(2,cl2), rep(3,cl3))

eqscplot(x, y, ratio = 1, tol = 0.04)

data <- cbind(x,y,labels)
write.table(data, file = "standard.txt", row.names=FALSE, col.names=FALSE)

