__author__ = 'Alex'

# converts a csv file to a tex table.
from re import sub
import numpy as np

def convert_csv_to_tex(file):

    # you neet to cd to the actual directory and enter the
    # csv name with extension.
    str_csv_file_dir = "Results/" + file + "_eval.csv"
    str_tex_file = "Results/" + file + "_eval.tex"
    str_csv_file_dir = file + "_eval.csv"
    str_tex_file =  file + "_eval.tex"

    # read csv file
    dataset = np.array(np.genfromtxt(str_csv_file_dir, dtype=["S25", float, float, float, float], delimiter=',', names=True))
    np.set_printoptions(precision=2)

    # tex document format
    str_tex_start = ''
    str_tex_end = '\\end{table}'

    # table format
    # get number of columns
    tex_tab_start = ['\\centering\n\t\\begin{tabular}{l']
    for int_col in range(0, len(dataset[0])-1):
        tex_tab_start.append('c')
    tex_tab_start.append('}\n\t\t\\toprule \n')
    tex_tab_start.append('\t\tAlgorithm & $E$ & $P$ & $V$ & $F$ \\\\')
    tex_tab_start.append('\n\t\t\\midrule \n')
    str_tex_tab_start = ''.join(tex_tab_start)


    # get maximal values
    maximal_values = [-1]
    minimal_values = [-1]
    for j in range(1, len(dataset[0])):
        max_col = round(dataset[0][j], 2)
        min_col = round(dataset[0][j], 2)
        for i in range(0, dataset.shape[0]):
            if j == 1:
                val = round(dataset[i][j], 2)
                if val < max_col:
                    max_col = val
                if val > min_col:
                    min_col = val
            else:
                val = round(dataset[i][j], 2)
                if val > max_col:
                    max_col = val
                if val < min_col:
                    min_col = val
        maximal_values.append(max_col)
        minimal_values.append(min_col)


    # change the csv rows to tex rows
    list_tex_rows = []
    for i in range(0, dataset.shape[0]):
        list_tex_rows.append("\t\t"+str(dataset[i][0].decode("utf-8")))
        for j in range(1, len(dataset[i])):
            if maximal_values[j] != minimal_values[j]:
                if round(dataset[i][j],2) == maximal_values[j]:
                    list_tex_rows.append(" & \\textbf{ %0.2f }"%(round(dataset[i][j], 2)))
                elif round(dataset[i][j],2) == minimal_values[j]:
                    list_tex_rows.append(" & \\textit{ %0.2f }"%(round(dataset[i][j], 2)))
                else:
                    list_tex_rows.append(" & %0.2f"%(round(dataset[i][j], 2)))
            else:
                list_tex_rows.append(" & %0.2f" % (round(dataset[i][j], 2)))

        list_tex_rows.append('\t\\\\\n')
    str_tex_rows = ''.join(list_tex_rows)


    # build output
    list_full_tex_output = ["\\begin{table}\n",
                            "\t\\caption{Evaluation results for the \""+file+"\" dataset}\n",
                            "\t\\label{tab:eval_"+file+"}\n",
                            str_tex_tab_start,
                            str_tex_rows,
                            "\t\t\\bottomrule\n",
                            "\t\\end{tabular}\n",
                            "\\end{table}"]

    # create output file
    file_output = open(str_tex_file, 'w')
    file_output.write(''.join(list_full_tex_output))
    file_output.close()

if __name__ == "__main__":
    files = ["Blobs-1000D", "Moons", "Spiral", "Compound", "Standard", "Aggregation", "Flame", "Moons-DifDense"]
    for file in files:
        convert_csv_to_tex(file)