__author__ = 'Alex'
import prettyplotlib as ppl

import matplotlib.pyplot as plt
from hierarchicalDBSCAN.Datasets.DatasetLoader import *
from sklearn.metrics import pairwise_distances
from hierarchicalDBSCAN.ClusteringAlgorithms.minPtsGraphDBScan import *

#dataset, labels_true = generate_dataset("moons", {"n_samples": 100, "noise": 0.075, "random_state":None})
dataset, labels_true = standard()

base_colors = [(255,187,120),(255,127,14),(174,199,232),(44,160,44),(31,119,180),(255,152,150),(214,39,40),
               (197,176,213),(152,223,138),(148,103,189),(247,182,210),(227,119,194),(196,156,148),(140,86,75),
               (127,127,127),(219,219,141),(199,199,199),(188,189,34),(158,218,229),(23,190,207)]

labels = ["add node to cluster", "node becomes core", "new core leads to merge", "cores become density reachable"]
label_names = ["new node", "new core", "new core merge", "merge", ""]
colors = {label: [t/255 for t in base_colors[i*3]] for i, label in enumerate(labels)}

statistics = dendrogram_distribution(dataset)
print(statistics)


fig = plt.figure(figsize=(7, 2.5))


art = []
for i, label in enumerate(labels):
    ppl.plot(plt.gca(), statistics["k"],  statistics[label_names[i]], color=colors[label], lw=2.5, label=str(label), alpha=0.5)
lgd = ppl.legend(loc=9, bbox_to_anchor=(0.5, -0.2), ncol=2, frameon=False)
art.append(lgd)
plt.xlabel(r'$min_{Pts}$')
plt.ylabel('number of occurrences')

fig.tight_layout()
#plt.show(additional_artists=art)
plt.show()

fig.savefig('../../latex script/images/dendrogram_merges.png', additional_artists=art, bbox_inches="tight")

#plt.savefig(name, additional_artists=art, bbox_inches="tight")
