__author__ = 'Alex'

import numpy as np
import matplotlib.pyplot as plt
import prettyplotlib as ppl
from hierarchicalDBSCAN.ClusteringAlgorithms.minPtsGraphDBScan import *
from hierarchicalDBSCAN.ClusterValidation.InternalValidation import modified_silhouette_score


if __name__ == "__main__":
    np.random.seed(17041991)
    dataset, labels_true = standard()
    N = len(dataset)

    db = minPtsGraphDBScan(minPts=5)
    distance_matrix = pairwise_distances(dataset)
    db.fit(dataset, distance_matrix, max_range=3)

    fig = plt.figure(figsize=(12, 5))

    """
    label_gen = db.cut_height_label_gen(detailed_hierarchy=True)
    heights = []
    scores = []
    for (height, labels, clusterheights) in label_gen:
        filtered_dataset, filtered_labels = (dataset, labels)
        if len(set(filtered_labels)) < 2 or len(set(filtered_labels)) == N:
            continue

        score = modified_silhouette_score(distance_matrix, np.array(filtered_labels), clusterheights, metric="precomputed")
        heights.append(height)
        scores.append(score)
    plt.plot(heights, scores, marker="x", c="b")
    """

    label_gen = db.cut_height_label_gen(detailed_hierarchy=False)
    heights = []
    scores = []
    for (height, labels, clusterheights) in label_gen:
        filtered_dataset, filtered_labels = (dataset, labels)
        if len(set(filtered_labels)) < 2 or len(set(filtered_labels)) == N:
            continue

        print(height, labels[1:20], clusterheights)

        score = modified_silhouette_score(distance_matrix, np.array(filtered_labels), clusterheights, metric="precomputed")
        print(score)

        heights.append(height)
        scores.append(score)
    plt.plot(heights, scores, marker="o", c="g")

    plt.show()